/*
Copyright 2002-2005 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss;


/**
 * Similar to java.lang.IllegalArgumentException,
 * except this inherits from Exception, not RuntimeException.
 * This new class is required because J2EE containers deal with
 * RuntimeException in a special way.  See EJB specification.
 * <p>
 * This exception is thrown if the argument of a remote
 * method is invalid.
 * <p>
 * Note: This exception replaces the deprecated javax.oss.IllegalArgumentException
 *
 * @author OSS through Java Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.2
 * @since August 2005
 * @ossj:exception
 */
//AB decision 2005-08-12: Use OSS prefix for all OSSJ exception and respect the Exception inheritence
public class OssIllegalArgumentException extends Exception {
//public class OssIllegalArgumentException extends IllegalArgumentException {
    /**
     * Constructs an OssIllegalArgumentException with no detail message.
     */
    public OssIllegalArgumentException() {
        super();
    }

    /**
     * Constructs an OssIllegalArgumentException with the specified detail message.
     *
     * @param message the detail message.
     */
    public OssIllegalArgumentException(String message) {
        super(message);
    }
}
