
package org.ossj.xml.common.v1_5;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlType;


/**
 * The <CODE>ManagedEntityValue</CODE> interface is the base interface for all more
 *                 detailed interfaces which represent any kind of object that is to be managed.
 *                 <p>
 *                 Classes which implement <CODE>ManagedEntityValue</CODE> or a
 *                 sub interface of <CODE>ManagedEntityValue</CODE>.
 *                 are also called value classes.
 *                 <P>All classes implementing a value interface provide several ways to access
 *                 the attributes:
 *                 <UL>
 *                 <LI>Attributes can be accessed through standard JavaBeans get/set (is/set)
 *                 methods.
 *                 <LI>Attributes can be accessed through the generic methods defined
 *                 in Attribute Access
 *                 <UL>
 *                 <LI><CODE>public Object getAttributeValue(String attributeName)</CODE>
 *                 <LI><CODE>public void setAttributeValue(String attributeName, Object newValue)</CODE>
 *             </UL>
 * 
 * <p>Java class for ManagedEntityValue complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="ManagedEntityValue">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="lastUpdateVersionNumber" type="{http://www.w3.org/2001/XMLSchema}long" minOccurs="0"/>
 *         &lt;element name="key" type="{http://ossj.org/xml/Common/v1-5}ManagedEntityKey" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ManagedEntityValue", propOrder = {
    "lastUpdateVersionNumber",
    "key"
})
public abstract class ManagedEntityValue {

    protected Long lastUpdateVersionNumber;
    protected ManagedEntityKey key;

    /**
     * Gets the value of the lastUpdateVersionNumber property.
     * 
     * @return
     *     possible object is
     *     {@link Long }
     *     
     */
    public Long getLastUpdateVersionNumber() {
        return lastUpdateVersionNumber;
    }

    /**
     * Sets the value of the lastUpdateVersionNumber property.
     * 
     * @param value
     *     allowed object is
     *     {@link Long }
     *     
     */
    public void setLastUpdateVersionNumber(Long value) {
        this.lastUpdateVersionNumber = value;
    }

    /**
     * Gets the value of the key property.
     * 
     * @return
     *     possible object is
     *     {@link ManagedEntityKey }
     *     
     */
    public ManagedEntityKey getKey() {
        return key;
    }

    /**
     * Sets the value of the key property.
     * 
     * @param value
     *     allowed object is
     *     {@link ManagedEntityKey }
     *     
     */
    public void setKey(ManagedEntityKey value) {
        this.key = value;
    }

}
